/**
 * Autor 			: Alexandre Correia - alexandrecorreia@celepar.pr.gov.br
 * Data 			: 00/00/0000
 * Caso de Teste	: EL-938:Adicionar compromisso
 * 
 * Descrio do Processo de Teste Cadastro no TestLink - http://testlink.expressolivre.org/ 
 * 
 * AES DO PASSO
 * P01. Usurio aciona opo para criar novo compromisso na agenda;
 * P02. Sistema apresenta tela para adicionar compromisso;
 * P03. Sistema apresenta campo para seleo do tipo do compromisso;
 * P04. Sistema apresenta campo para entrar com um ttulo para o compromisso;
 * P05. Sistema apresenta campo para seleo da categoria do compromisso;
 * P06. Sistema apresenta campo para informar a localizao do compromisso;
 * P07. Sistema apresenta campo para seleo da data de incio do compromisso;
 * P08. Sistema apresenta campo para informar hora inicial do compromisso;
 * P09. Sistema apresenta campo para seleo da data final do compromisso;
 * P10. Sistema apresenta campo para informar hora final do compromisso;
 * P11. Sistema apresenta campo para seleo da prioridade do compromisso;
 * ( PENDENTE )P12. Sistema apresenta campo para adicionar remover participantes do compromisso; ( PENDENTE )
 * P13. Sistema apresenta opo para avisar participantes externos;
 * P14. Sistema apresenta opo para participao do prprio usurio;
 * P15. Sistema apresenta campos para acionar alarme para o compromisso: dias, horas e minutos;
 * P16. Sistema apresenta campo para selecionar o tipo de repetio do compromisso;
 * P17. Sistema apresenta campo para informar a data final da repetio;
 * P18. Sistema apresenta campos para repetio semanal: segunda, tera, quarta, quinta, sexta, sbado, domingo
 * P19. Sistema apresenta campo para informar o intervalo da repetio do compromisso;
 */

package br.gov.serpro.cte.agenda.casoteste;

import java.util.GregorianCalendar;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import br.gov.serpro.cte.agenda.Objetos.AdicionarCompromissoEL938.Campo;
import br.gov.serpro.cte.agenda.Objetos.AdicionarCompromissoEL938.Valor;
import br.gov.serpro.cte.connection.DAOSelenium;
import br.gov.serpro.cte.connection.LoginExpresso;

import com.thoughtworks.selenium.SeleneseTestCase;

public class Test_EL_938_AdicionarCompromisso extends SeleneseTestCase
{
	@Before
	public void setUp() throws Exception
	{
		String url			= "https://cte.serpro.gov.br";
		DAOSelenium conn	= new DAOSelenium( "localhost", 4444, "*pifirefox", url);
		selenium			= conn.newConnection();
	}
	@Test
	public void testa()
	{
		// Logando No Expresso
		selenium.open("/login.php");
		selenium.type("user", LoginExpresso.USER_EXPRESSO.getValue());
		selenium.type("passwd", LoginExpresso.PASSWORD_EXPRESSO.getValue());
		selenium.click("submitit");
		selenium.waitForPageToLoad("30000");
		selenium.click("//html/body/div[@id='toolbar']/table/tbody/tr/td[2]/table/tbody/tr/td[3]/a/img[@id='calendarid']");

		// Data
		GregorianCalendar gc = new GregorianCalendar();
		String	Dia = String.valueOf( gc.get( gc.DAY_OF_MONTH ) );
				Dia = ( Dia.length() > 1 ) ? Dia : "0"+Dia; 
		
		String	Mes = String.valueOf( gc.get( gc.MONTH ) + 1 );
		
		String	Ano = String.valueOf( gc.get( gc.YEAR ) );
		
		//Adicionando um Evento
		selenium.open("/index.php?date=" + Ano + Mes + Dia + "&menuaction=calendar.uicalendar.week");
		selenium.click("//img[@title='Nova Entrada']");
		selenium.waitForPageToLoad("30000");
		
		for( Campo cmp : Campo.values() )
		{
			String cmpName = cmp.name();
				 
			if( cmp.getValue().indexOf("addSelection:") > -1 )
			{	
				AddSelection( cmp.getValue(), getValor( cmp.name() ) );
			}
			
			if( cmp.getValue().indexOf("click:") > -1 )
			{
				Click( cmp.getValue() );
			}
			
			if( cmp.getValue().indexOf("select:") > -1 )
			{
				Select( cmp.getValue(), getValor( cmp.name() ) );
			}
			
			if( cmp.getValue().indexOf("type:") > -1 )
			{
				Type( cmp.getValue(), getValor( cmp.name() ) );
			}
		}
		
		selenium.waitForPageToLoad("10000");
	}
	
	public String getValor(String cmpName)
	{
		String _return = "";
		
		for( Valor vlr : Valor.values() )
		{
			 String vlrName = vlr.name();
			 
			 if( vlrName.equals( cmpName ) )
			 {
				 _return = vlr.getValue();
			 }
		}
		
		return _return;
	}
	
	public void AddSelection( String locator, String optionLocator )
	{
		selenium.addSelection( locator.substring( 13 , locator.length() ), optionLocator );
	}
	
	public void Click( String locator )
	{
		selenium.click( locator.substring( 6 , locator.length() ) );
	}

	public void Select( String selectLocator, String optionLocator )
	{
		selenium.select( selectLocator.substring( 7 , selectLocator.length() ), optionLocator );
	}

	public void Type( String locator, String value )
	{
		selenium.type( locator.substring( 5 , locator.length() ), value );
	}
	
	@After
	public void tearDown() throws Exception
	{
		selenium.close();
	}
}